/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* gdome-xml-event.h
 *
 * Copyright (C) 1999 Raph Levien <raph@acm.org>
 * Copyright (C) 2000 Mathieu Lacage <mathieu@gnu.org>
 * Copyright (C) 2000 Anders Carlsson <andersca@gnu.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */


/* --------------------------------------------------------------- */
/* ---------------------------  Event  --------------------------- */
/* --------------------------------------------------------------- */


#ifndef GDOME_EVENT_FILE
#define GDOME_EVENT_FILE



typedef struct _Gdome_xml_Event Gdome_xml_Event;
typedef struct _Gdome_xml_EventPriv Gdome_xml_EventPriv;



struct _Gdome_xml_EventPriv {
	char *type;
	GdomeNode *target;
	xmlNode *currentTarget;
	int eventPhase;
	GdomeBoolean bubbles;
	GdomeBoolean cancelable;	
	GdomeBoolean propagation_stopped;
	GdomeBoolean default_prevented;
	GdomeDOMTimeStamp timestamp;
};

struct _Gdome_xml_Event {
  GdomeEvent super;
  int refcnt;
  Gdome_xml_EventPriv *ev;
};




void              gdome_xml_evnt_ref              (GdomeEvent *self, 
																									 GdomeException *exc);
void              gdome_xml_evnt_unref            (GdomeEvent *self, 
																									 GdomeException *exc);
void            * gdome_xml_evnt_query_interface  (GdomeEvent *self, 
																									 const char *interface, 
																									 GdomeException *exc);
GdomeDOMString  * gdome_xml_evnt_type             (GdomeEvent *self, 
																									 GdomeException *exc);
GdomeNode       * gdome_xml_evnt_target           (GdomeEvent *self, 
																									 GdomeException *exc);
GdomeNode       * gdome_xml_evnt_currentTarget    (GdomeEvent *self, 
																									 GdomeException *exc);
unsigned short    gdome_xml_evnt_eventPhase       (GdomeEvent *self, 
																									 GdomeException *exc);
GdomeBoolean      gdome_xml_evnt_bubbles          (GdomeEvent *self, 
																									 GdomeException *exc);
GdomeBoolean      gdome_xml_evnt_cancelable       (GdomeEvent *self, 
																									 GdomeException *exc);
GdomeDOMTimeStamp gdome_xml_evnt_timeStamp        (GdomeEvent *self,
																									 GdomeException *exc);
void              gdome_xml_evnt_stopPropagation  (GdomeEvent *self, 
																									 GdomeException *exc);
void              gdome_xml_evnt_preventDefault   (GdomeEvent *self, 
																									 GdomeException *exc);
void              gdome_xml_evnt_initEvent        (GdomeEvent *self, 
																									 GdomeDOMString *eventTypeArg, 
																									 GdomeBoolean canBubbleArg, 
																									 GdomeBoolean cancelableArg, 
																									 GdomeException *exc);



const GdomeEventVtab gdome_xml_evnt_vtab;

#endif /* GDOME_EVENT_FILE */




