/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* gdome-xml-str.h
 *
 * Copyright (C) 1999 Raph Levien <raph@acm.org>
 * Copyright (C) 2000 Mathieu Lacage <mathieu@gnu.org>
 * Copyright (C) 2001 Paolo Casarini <paolo@casarini.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */


#ifndef GDOME_STR_FILE
#define GDOME_STR_FILE

GdomeDOMString     *gdome_xml_str_mkref       (const gchar *str);
GdomeDOMString     *gdome_xml_str_mkref_own   (gchar *str);
GdomeDOMString     *gdome_xml_str_mkref_xml   (xmlChar *str);
GdomeDOMString     *gdome_xml_str_mkref_dup   (gchar *str);

void                gdome_xml_str_ref         (GdomeDOMString *self);
void                gdome_xml_str_unref       (GdomeDOMString *self);

GdomeBoolean        gdome_xml_str_equal       (GdomeDOMString *self,
                                               GdomeDOMString *str);

/*------------ PROTOTYPES OLD OR TO BE REMOVED ------------*/
GdomeDOMString     *gdome_xml_str_mkref_nop        (const char *str);
void                gdome_xml_str_unref_nop        (GdomeDOMString *self);
void                gdome_xml_str_unref_own        (GdomeDOMString *self);
GdomeDOMString     *gdome_xml_str_mkref_xmlfree    (char *str);
void                gdome_xml_str_unref_xmlfree    (GdomeDOMString *self);
void                gdome_xml_str_unref1           (GdomeDOMString *self);


#endif GDOME_STR_FILE
