/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */

#include <gdome.h>
#include <parser.h>
#include <tree.h>
#include <gdome-util.h>

/* this test shows why the current NodeList 
	 implementation does not work */

int main (int argc, char *argv[])
{
  xmlDocPtr doc = NULL;
  GdomeDocument *gdoc = NULL;
  GdomeNodeList *node_list = NULL;
  GdomeElement *top_level = NULL;
  GdomeException exc;
  GdomeNode *node = NULL;
  GdomeDOMString *string = NULL;
	GdomeNode *text_node = NULL;
  
  if (argc < 2)
    {
      fprintf (stderr, "usage: test-gdome test.xml\n");
      exit (1);
    }

  doc = xmlParseFile (argv[1]);
  gdoc = gdome_xml_from_document (doc);

  top_level = gdome_doc_documentElement (GDOME_DOC (gdoc), &exc);
  node_list = gdome_n_childNodes (GDOME_N (top_level), &exc);

	/* remove child */
  node = gdome_nl_item (GDOME_NL (node_list), 5, &exc);	
	gdome_n_removeChild (GDOME_N (top_level), node, &exc);
	gdome_n_unref (GDOME_N (node), &exc);

	/* get to the removed child in the list view */
	node = gdome_nl_item (GDOME_NL (node_list), 5, &exc);
	text_node = gdome_n_firstChild (GDOME_N (node), &exc);
	string = gdome_n_nodeValue (GDOME_N (text_node), &exc);


	/* test to make sure the  removed,node is not the one
		 we removed but the one just after */
	if (strcmp (string->str, "stuff2") == 0) {
		/* unfortunately, the removed node is still there :( */
		gdome_str_unref (string);
		fprintf (stderr, "Error: Node List badly implemented\n");
		exit (1);
	} 

	gdome_str_unref (string);
  return 0;
}
